#include <extdll.h>
#include <dllapi.h>
#include <meta_api.h>


#include "LogListener.h"
#include "StandardParser.h"

DLL_FUNCTIONS gFunctionTable;

void logdServerActivate(edict_t *pEdictList, int edictCount, int clientMax)
{
    parserActivate();
    listenerActivate();
	RETURN_META(MRES_HANDLED);
}

void logdServerDeactivate(void)
{
    parserDeactivate();
    listenerDeactivate();
	RETURN_META(MRES_HANDLED);
}

C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	if(!pFunctionTable) {
		UTIL_LogPrintf("GetEntityAPI2 called with null pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) {
		UTIL_LogPrintf("GetEntityAPI2 version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
		//! Tell engine what version we had, so it can figure out who is out of date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memset(&gFunctionTable, 0, sizeof(gFunctionTable));
	gFunctionTable.pfnServerActivate = logdServerActivate;
	gFunctionTable.pfnServerDeactivate = logdServerDeactivate;

	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

