/* Natives for log interaction
 *
 * (c) Copyright 2002, dJeyL
 * No warranties of any kind.
 *
 */


#include <extdll.h>		// always
#include <sdk_util.h>
#include <meta_api.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include "modules.h"
#include "LogListener.h"
#include "StandardParser.h"

#include "LogEvents.h"

#define CALL_LIST_SIZE ( HIGHEST_EVENT_CODE + 1 )

extern LogListener* callList[ CALL_LIST_SIZE ];

module_info_s module_info = {
  "LogD for MetaSmall", // name
  "dJeyL", // author
  "1.00.5", // version
  MS_IVERS,
};

void insertEvent(AMX *amx,int code,char *cmd)
{
    int idx;
    LogListener* current;
    if(AMX_FINDPUBLIC(amx,cmd,&idx)!=AMX_ERR_NONE)
    {
    	return;
    }
    
    current = callList[ code ];
    while( current )
    {
    	current = current->next;
    }

	funcall_t *unused;

    //create Listener and add it since it doesn't exist
    current = new LogListener;
    current->next = callList[ code ];
    current->amx = amx;
    current->plugin = (plugin_t*)amx;
    current->funcall = NULL;
    CREATE_FUNC_CALL(&(current->funcall),&unused,current->plugin,cmd);
    callList[ code ] = current;

	parseRoutineActive( code, TRUE );
}

#define REG_EVT(id,func) insertEvent(amx,id,func)

static cell AMX_NATIVE_CALL logd_init(AMX *amx, cell *params) // 0 param
{
	
	REG_EVT(1,"logd_cvar");
	REG_EVT(2,"logd_log");
	REG_EVT(3,"logd_map");
	REG_EVT(4,"logd_rcon");
	REG_EVT(5,"logd_hostname");
	REG_EVT(6,"logd_server_say");
	REG_EVT(50,"logd_connect");
	REG_EVT(51,"logd_enter");
	REG_EVT(52,"logd_disconnect");
	REG_EVT(53,"logd_suicide");
	REG_EVT(54,"logd_team_select");
	REG_EVT(55,"logd_role_select");
	REG_EVT(56,"logd_name_change");
	REG_EVT(57,"logd_kill");
	REG_EVT(58,"logd_injure");
	REG_EVT(59,"logd_players_action");
	REG_EVT(60,"logd_player_action");
	REG_EVT(61,"logd_team_action");
	REG_EVT(62,"logd_world_action");
	REG_EVT(63,"logd_chat");
	REG_EVT(64,"logd_team_alliance");
	REG_EVT(65,"logd_team_score");
	REG_EVT(66,"logd_private_chat");

	return (cell)1;	
}


#define MAX_PARM_SIZE 257

cell ret;
cell s1[MAX_PARM_SIZE];
cell s2[MAX_PARM_SIZE];
cell s3[MAX_PARM_SIZE];
cell s4[MAX_PARM_SIZE];
LogListener* current;
int mycursor;

#define GET_STRING(thing) (cell)thing-(cell)current->amx->base-(cell)((AMX_HEADER *)current->amx->base)->dat
#define EXEC_PARAMS current->amx,&ret,current->funcall->func

#define COPY_STRING(S,P) for(mycursor=0;mycursor<MAX_PARM_SIZE&&P[mycursor];mycursor++)S[mycursor]=P[mycursor];S[mycursor]='\0'

void notifyMSi( int cod, int p1)
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	AMX_EXEC(EXEC_PARAMS,1,(cell)p1);
        current = current->next;
    }
}

void notifyMSis( int cod, int p1, char *p2 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s2,p2);
    	AMX_EXEC(EXEC_PARAMS,2,(cell)p1,GET_STRING(s2));
        current = current->next;
    }
}

void notifyMSiss( int cod, int p1, char *p2, char *p3 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s2,p2);
    	COPY_STRING(s3,p3);
    	AMX_EXEC(EXEC_PARAMS,3,(cell)p1,GET_STRING(s2),GET_STRING(s3));
        current = current->next;
    }
}

void notifyMSiis( int cod, int p1, int p2, char *p3 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s3,p3);
    	AMX_EXEC(EXEC_PARAMS,3,(cell)p1,(cell)p2,GET_STRING(s3));
        current = current->next;
    }
}

void notifyMSiiss( int cod, int p1, int p2, char *p3, char *p4 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s3,p3);
    	COPY_STRING(s4,p4);
    	AMX_EXEC(EXEC_PARAMS,4,(cell)p1,(cell)p2,GET_STRING(s3),GET_STRING(s4));
        current = current->next;
    }
}

void notifyMSiisi( int cod, int p1, int p2, char *p3, int p4 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s3,p3);
    	AMX_EXEC(EXEC_PARAMS,4,(cell)p1,(cell)p2,GET_STRING(s3),(cell)p4);
        current = current->next;
    }
}

void notifyMSs( int cod, char *p1 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s1,p1);
    	AMX_EXEC(EXEC_PARAMS,1,GET_STRING(s1));
        current = current->next;
    }
}

void notifyMSss( int cod, char *p1, char *p2 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s1,p1);
    	COPY_STRING(s2,p2);
    	AMX_EXEC(EXEC_PARAMS,2,GET_STRING(s1),GET_STRING(s2));
        current = current->next;
    }
}

void notifyMSsss( int cod, char *p1, char *p2, char *p3 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s1,p1);
    	COPY_STRING(s2,p2);
    	COPY_STRING(s3,p3);
    	AMX_EXEC(EXEC_PARAMS,3,GET_STRING(s1),GET_STRING(s2),GET_STRING(s3));
        current = current->next;
    }
}

void notifyMSssss( int cod, char *p1, char *p2, char *p3, char *p4 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s1,p1);
    	COPY_STRING(s2,p2);
    	COPY_STRING(s3,p3);
    	COPY_STRING(s4,p4);
    	AMX_EXEC(EXEC_PARAMS,4,GET_STRING(s1),GET_STRING(s2),GET_STRING(s3),GET_STRING(s4));
        current = current->next;
    }
}

void notifyMSsiis( int cod, char *p1, int p2, int p3, char *p4 )
{
    current = callList[ cod ];
    while( current ) //while we have actual structures in the list
    {
    	COPY_STRING(s1,p1);
    	COPY_STRING(s4,p4);
    	AMX_EXEC(EXEC_PARAMS,4,GET_STRING(s1),(cell)p2,cell(p3),GET_STRING(s4));
        current = current->next;
    }
}





AMX_NATIVE_INFO logd_Natives[] = {
  { "logd_init",    logd_init },
  { NULL, NULL }
};


pfnamx_engine_g* g_engAmxFunc;
pfnms_engine_g* g_engMetaSmallFunc;
C_DLLEXPORT int MetaSmall_Attach(module_info_s** info,pfnamx_engine_g* amxeng,pfnms_engine_g* mseng) {
  *info = &module_info;
  g_engAmxFunc = amxeng;
  g_engMetaSmallFunc = mseng;
  ADD_NATIVES(logd_Natives);
  return(1);
}

